/*
 * bldc.h
 *
 *  Created on: 1 Feb 2025
 *      Author: user
 */

#ifndef BLDC_H_
#define BLDC_H_

#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>

// Constants
#define START_DUTY_CYCLE 10

// Global Variables
extern volatile bool free_running;
extern volatile int wait_counter;
extern volatile bool waiting_for_falling_edge;
extern volatile int threshold;

extern volatile uint8_t current_phase;
extern volatile uint8_t current_duty_cycle;

// Function Prototypes
void bldc_motor_init(void);
void bldc_motor_set_speed(int percentage);
void bldc_motor_stop(void);
void bldc_force_commute_start(void);
void commute(void);
int configure_off(void);
uint8_t reconfigure_for_phase(uint8_t phase, uint8_t duty_cycle);
void motor_bemf_irq_handler(void);

#endif /* BLDC_H_ */
